summarylogtreecommitdiffstats
path: root/PKGBUILD
diff options
context:
space:
mode:
authorFantix King2015-11-01 12:49:18 +0800
committerFantix King2015-11-01 15:02:52 +0800
commit052102d1f699e17c805a04f96746711fa6aba0c4 (patch)
tree8f052b7a9a2a5d7610c95e9be9d71e8e17d700c2 /PKGBUILD
downloadaur-052102d1f699e17c805a04f96746711fa6aba0c4.tar.gz
2.22-3.1
Diffstat (limited to 'PKGBUILD')
-rw-r--r--PKGBUILD173
1 files changed, 173 insertions, 0 deletions
diff --git a/PKGBUILD b/PKGBUILD
new file mode 100644
index 00000000000..b66913908f4
--- /dev/null
+++ b/PKGBUILD
@@ -0,0 +1,173 @@
+# $Id: PKGBUILD 144552 2015-10-21 09:06:37Z heftig $
+# Maintainer: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
+# Contributor: Jan de Groot <jgc@archlinux.org>
+# Contributor: Allan McRae <allan@archlinux.org>
+# x32 Maintainer: Fantix King <fantix.king@gmail.com>
+
+# toolchain build order: linux-api-headers->glibc->binutils->gcc->binutils->glibc
+# NOTE: valgrind-multilib requires rebuild with each major glibc version
+
+
+_pkgbasename=glibc
+pkgname=libx32-$_pkgbasename
+pkgver=2.22
+pkgrel=3.1
+pkgdesc="GNU C Library (x32 ABI)"
+arch=('x86_64')
+url="http://www.gnu.org/software/libc"
+license=('GPL' 'LGPL')
+groups=()
+depends=()
+makedepends=('gcc-multilib-x32>=5.2')
+backup=()
+conflicts=('glibc-x32-seed')
+provides=('glibc-x32-seed')
+
+
+options=('!strip' 'staticlibs' '!emptydirs')
+
+source=(http://ftp.gnu.org/gnu/libc/${_pkgbasename}-${pkgver}.tar.xz{,.sig}
+ glibc-2.22-roundup.patch
+ libx32-glibc.conf)
+md5sums=('e51e02bf552a0a1fbbdc948fb2f5e83c'
+ 'SKIP'
+ 'b6b7a0e8d6e6520e40e3164ae773631d'
+ '34a4169d2bdc5a3eb83676a0831aae57')
+validpgpkeys=('F37CDAB708E65EA183FD1AF625EF0A436C2A4AFF') # Carlos O'Donell
+
+prepare() {
+ cd ${srcdir}/glibc-${pkgver}
+
+ # glibc-2.21..01b07c70
+ patch -p1 -i $srcdir/glibc-2.22-roundup.patch
+
+ mkdir ${srcdir}/glibc-build
+}
+
+build() {
+ cd ${srcdir}/glibc-build
+
+ #if [[ ${CARCH} = "i686" ]]; then
+ # Hack to fix NPTL issues with Xen, only required on 32bit platforms
+ # TODO: make separate glibc-xen package for i686
+ #export CFLAGS="${CFLAGS} -mno-tls-direct-seg-refs"
+ #fi
+
+ if [ -x "/opt/gcc-x32-seed/bin/gcc" ]; then
+ echo "Using gcc-x32-seed"
+ gcc_home=`ls -d /opt/gcc-x32-seed/lib/gcc/x86_64-unknown-linux-gnu/*/`
+ export CC="/opt/gcc-x32-seed/bin/gcc -mx32 -B"${gcc_home}
+ export CXX="/opt/gcc-x32-seed/bin/g++ -mx32 -B"${gcc_home}
+ seed_params='--target=x86_64-x32-linux --build=x86_64-linux --host=x86_64-x32-linux'
+ else
+ echo "Using gcc-multilib-x32"
+ export CC="gcc -mx32"
+ export CXX="g++ -mx32"
+ seed_params=''
+ fi
+ echo "slibdir=/usr/libx32" >> configparms
+ echo "rtlddir=/usr/libx32" >> configparms
+ echo "sbindir=/usr/bin" >> configparms
+ echo "rootsbindir=/usr/bin" >> configparms
+
+ # remove hardening options for building libraries
+ CFLAGS=${CFLAGS/-fstack-protector-strong/}
+ CPPFLAGS=${CPPFLAGS/-D_FORTIFY_SOURCE=2/}
+
+ ${srcdir}/${_pkgbasename}-${pkgver}/configure --prefix=/usr \
+ --libdir=/usr/libx32 --libexecdir=/usr/libx32 \
+ --with-headers=/usr/include \
+ --with-bugurl=https://bugs.archlinux.org/ \
+ --enable-add-ons \
+ --enable-obsolete-rpc \
+ --enable-kernel=2.6.32 \
+ --enable-bind-now --disable-profile \
+ --enable-stackguard-randomization \
+ --enable-lock-elision \
+ --enable-multi-arch \
+ --disable-werror \
+ ${seed_params} \
+ x86_64-unknown-linux-gnux32
+
+ # build libraries with hardening disabled
+ echo "build-programs=no" >> configparms
+ make
+
+ # re-enable hardening for programs
+ sed -i "/build-programs=/s#no#yes#" configparms
+ echo "CC += -fstack-protector-strong -D_FORTIFY_SOURCE=2" >> configparms
+ echo "CXX += -fstack-protector-strong -D_FORTIFY_SOURCE=2" >> configparms
+ make
+
+ # remove harding in preparation to run test-suite
+ sed -i '5,7d' configparms
+}
+
+check() {
+ cd ${srcdir}/glibc-build
+
+ if [ -x "/opt/gcc-x32-seed/bin/gcc" ]; then
+ make check || true
+ else
+ # some failures are "expected"
+ make check || true
+ fi
+}
+
+package() {
+ cd ${srcdir}/glibc-build
+
+
+
+
+ make install_root=${pkgdir} install
+
+ rm -rf ${pkgdir}/{etc,sbin,usr/{bin,sbin,share},var}
+
+ # We need to keep x32 ABI specific header files
+ find ${pkgdir}/usr/include -type f -not -name '*-x32.h' -delete
+
+
+ # Dynamic linker
+ mkdir ${pkgdir}/usr/lib
+ ln -s ../libx32/ld-linux-x32.so.2 ${pkgdir}/usr/lib/
+
+ # Add libx32 paths to the default library search path
+ install -Dm644 "$srcdir/libx32-glibc.conf" "$pkgdir/etc/ld.so.conf.d/libx32-glibc.conf"
+
+ # Symlink /usr/libx32/locale to /usr/lib/locale
+ ln -s ../lib/locale "$pkgdir/usr/libx32/locale"
+
+ # remove the static libraries that have a shared counterpart
+ # libc, libdl, libm and libpthread are required for toolchain testsuites
+ # in addition libcrypt appears widely required
+ rm $pkgdir/usr/libx32/lib{anl,BrokenLocale,nsl,resolv,rt,util}.a
+
+
+
+
+ # Do not strip the following files for improved debugging support
+ # ("improved" as in not breaking gdb and valgrind...):
+ # ld-${pkgver}.so
+ # libc-${pkgver}.so
+ # libpthread-${pkgver}.so
+ # libthread_db-1.0.so
+
+ cd $pkgdir
+ strip $STRIP_BINARIES \
+ \
+ \
+ usr/libx32/getconf/*
+
+
+ strip $STRIP_STATIC usr/libx32/*.a
+
+ strip $STRIP_SHARED usr/libx32/lib{anl,BrokenLocale,cidn,crypt}-*.so \
+ usr/libx32/libnss_{compat,db,dns,files,hesiod,nis,nisplus}-*.so \
+ usr/libx32/lib{dl,m,nsl,resolv,rt,util}-*.so \
+ usr/libx32/lib{memusage,pcprofile,SegFault}.so \
+ usr/libx32/{audit,gconv}/*.so || true
+
+ # Fix issue that core/glibc didn't fix the path to /lib/ld-linux-x32.so.2
+ ln -s /usr/lib ${pkgdir}/libx32
+}